/***
 * VARIABLES GLOBALS. 
 */
/***
 * usuari que es connecta a l'aplicaci
 */
var usuari;
/***
 * clau de l'usuari.
 */
var clau;
/***
 * array d'usuaris per mostrar llistes en modus "gesti"
 */
var usuaris = new Array();
/***
 * array de missatges (noms els pendents de lectura)
 */
var missatges = new Array();
/***
 * control per no avisar ms d'una vegada
 */
var avisat = false;
/***
 * mant la referencia al missatge seleccionat per edici
 */
var missatgeSel = null;
/***
 * fixa l'usuari de gesti al que s'enviaran els missatges
 */
var usuariQTN = 'qtn';
/***
 * array de reserves
 */
var agenda;
/***
 * array d'hores possibles per demanar reserves
 */
var hores = ["10_00", "11_00", "12_00", "13_00", "15_00", "16_00", "17_00", "18_00"];

/***
 * control de adrea base. Segons el navegador pot tenir problemes amb
 * les adreces relatives i el port 8080
 */
var server = window.location.hostname + ":" + window.location.port;
var path = window.location.pathname;
path = path.substr(0, path.lastIndexOf("/")) + "/";
var baseUrl = "http://" + server + path;

/***
 * mant el dia de la reserva que demana l'usuari
 */
var diaReserva = "";
/***
 * mant l'usuari pel que es fa la reserva en cas de usuari de gesti
 */
var usuariReserva = "";
/***
 * mant l'usuari a editar en les dades personals
 */
var usuariDP = "";
/***
 * dia reserva en format DMA
 */
var diaReservaDMA = "";
/***
 * mant la hora seleccionada de la reserva
 */
var horaReserva = "";
/***
 * mant la hora ne format text pels missatges
 */
var horaText = "";
/***
 * array de tipus de servei. En aquesta versi es fix.
 */
var serveis = new Array();
serveis["T"] = "Terap\u00E8utic";
serveis["R"] = "Relaxant";
serveis["E"] = "Est\u00E8tic";
serveis["G"] = "Energ\u00E8tic";
serveis["A"] = "Altres";

/***
 * array de dies setmana
 */
var diaSetmana = new Array(7);
diaSetmana[0] = "dg.";
diaSetmana[1] = "dl.";
diaSetmana[2] = "dt.";
diaSetmana[3] = "dc.";
diaSetmana[4] = "dj.";
diaSetmana[5] = "dv.";
diaSetmana[6] = "ds.";

/***
 * num dies a poder reservar. En futures versions podria variar
 * segons la capacitat de la pantalla
 */
var NUM_DIES = 5;
/***
 * array de relaci amb les dates de reserves
 */
var dates = new Array();
/**
 * index invers de les dates sobre l'array de dates
 */
var datesIdx = new Array();
/***
 * variable general per contadors de dies
 */
var idia = 0;
/***
 * mant el dia inicial de presentaci de dates
 */
var diaActual = new Date();
/***
 * preparaci de l'array de dates
 */
var ifestiu = 0;
var festius = new Array();
festius[ifestiu++] = new Date(2012, 11, 25);
festius[ifestiu++] = new Date(2012, 11, 26);
festius[ifestiu++] = new Date(2013, 0, 1);
festius[ifestiu++] = new Date(2013, 2, 29);
festius[ifestiu++] = new Date(2013, 3, 1);
festius[ifestiu++] = new Date(2013, 4, 1);
festius[ifestiu++] = new Date(2013, 5, 24);
festius[ifestiu++] = new Date(2013, 7, 15);
festius[ifestiu++] = new Date(2013, 8, 11);
festius[ifestiu++] = new Date(2013, 9, 12);
festius[ifestiu++] = new Date(2013, 10, 1);
festius[ifestiu++] = new Date(2013, 11, 6);
festius[ifestiu++] = new Date(2013, 11, 25);
festius[ifestiu++] = new Date(2013, 11, 26);

/***
 * controls per evitar refrescos a les pantalles.
 * en cas de produirse un refresc, es torna a la pantalla de 
 * connexi
 */
$('#pEntrada').live('pageshow', function(event) {
	//netejo estructures i variables
	$(".resultat").text("");
});
$('#pAgenda').live('pageshow', function(event) {
	$(".resultat").text("");
	if (usuari == undefined)
		demanaDadesRefresh();
	else if (missatges.length > 0 && !avisat) {
		avisat = true;
		$("#pMissatgesPendents").popup("open");		
	}
});
$('#pReserva').live('pageshow', function(event) {
	$(".resultat").text("");
	if (usuari == undefined)
		demanaDadesRefresh();
});
$('#pDadesPersonals').live('pageshow', function(event) {
	$(".resultat").text("");
	if (usuari == undefined)
		demanaDadesRefresh();
	else if (usuari.admin)
		carregaLlistaUsuaris();
});
$('#pAtencioClient').live('pageshow', function(event) {
	$(".resultat").text("");
	if (usuari == undefined)
		demanaDadesRefresh();
	else {
		if (usuari.admin)
			carregaLlistaUsuaris();
		carregaMissatges();
	}
});

$('#pAgenda').live('swipeleft', function(event) {
	$.mobile.changePage("#pDadesPersonals", { transition: "slide", reverse: false});
});
$('#pAgenda').live('swiperight', function(event) {
	$.mobile.changePage("#pAtencioClient", { transition: "slide", reverse: true});
});
$('#pDadesPersonals').live('swipeleft', function(event) {
	$.mobile.changePage("#pAtencioClient", { transition: "slide", reverse: false});
});
$('#pDadesPersonals').live('swiperight', function(event) {
	$.mobile.changePage("#pAgenda", { transition: "slide", reverse: true});
});
$('#pAtencioClient').live('swipeleft', function(event) {
	$.mobile.changePage("#pAgenda", { transition: "slide", reverse: false});
});
$('#pAtencioClient').live('swiperight', function(event) {
	$.mobile.changePage("#pDadesPersonals", { transition: "slide", reverse: true});
});
$('#pReserva').live('swiperight', function(event) {
	$.mobile.changePage("#pAgenda", { transition: "slide", reverse: true});
});

/***
 * indicador de cap de setmana.
 */
var capSetmana = 5;

/*
 ******************************************************************************
 * USUARIS
 ******************************************************************************
 */
/***
 * Objecte Usuari. facilita l'accs a les propietats de l'usuari quan el rebem.
 * @param {type} dades
 * @returns {Usuari}
 */
function Usuari(dades)
{
	this.usuari = dades.usuari;
	this.clau = dades.claudes;
	this.nom = dades.nom;
	this.cognoms = dades.cognoms;
	this.nif = dades.nif;
	this.telefon_fix = dades.telefon_fix;
	this.telefon_mobil = dades.telefon_mobil;
	this.data_naixement = dades.data_naixement;
	this.correu_e = dades.correu_e;
	this.admin = (dades.admin == 'S');
}

/***
 * funci que es crida inicialment i que s'encarrega d'obtenir la majoria de
 * dades. Fa crides ajax per demanar informaci que s'anir posant mitjanant
 * jQuery.
 * @returns {undefined}
 */
function demanaDadesUsuari()
{
	var idUsuari = document.getElementById("txtUsuari").value;
	var clau = document.getElementById("txtClau").value;
	var url = baseUrl + "dades/usuari.php?o=c&usuari=" + idUsuari + "&clau=" + clau;
	$.get(url, function(data) {
		preparaUsuari(data);
	}, "json")
			.error(function() {
		$(".resultat").text("Error prepararant dades usuari.").fadeIn(3000);
	});
}

function demanaDadesRefresh()
{
	var url = baseUrl + "dades/usuari.php?o=c";
	$.get(url, function(data) {
		preparaUsuari(data);
	}, "json")
			.error(function() {
		$(".resultat").text("Error prepararant dades usuari.").fadeIn(3000);
	});
}

/***
 * rep les dades demanades a demanaDadesUsuari() i genera els valors
 * inicials dels controls.
 * Tamb inicialitza la visualitzaci dels diferents elements de pantalla.
 * @param {type} dades
 * @returns {undefined}
 */
function preparaUsuari(dades) {
	if (!dades.resultat)
	{
		$(".resultat").text(dades.missatge).fadeIn(5000);
	}
	else
	{
		$(".resultat").text("");
		usuari = new Usuari(dades);

		mostraDadesUsuari(usuari);
		carregaMissatges();

		if (usuari.admin) {
			carregaLlistaUsuaris();
			$("#botoNouUsuari").show();
			$("#div-admin-dp").show();
		} else {
			$("#divUsuariDP").hide();
			$("#divUsuariReserva").hide();
			$("#botoConfirmar").hide();
			$("#botoRebutjar").hide();
			$("#div-admin-dp").hide();
			$("#divUsuariDPtxt").hide();
			$("#div-per-usuari").hide();
			$("#div-admin-dp").hide();
			$("#botoNouUsuari").hide();

		}

		$("#div-data-ac").hide();
		$("#div-resposta-ac").hide();
		$("#div-de-usuari").hide();
		$("#div-per-usuari").hide();
		$("#botoLlegirMissatge").hide();
		$("#botoLlistaMissatge").hide();
		$("#div-tipus-missatge").hide();
		$("#div-tipus-missatge-show").hide();

		//porta dades de les visites inicialment des de dilluns de la setmana en curs
		if (diaActual.getDay() == 0) {
			diaActual.setDate(diaActual.getDate() + 1);
		} else if (diaActual.getDay() == 6) {
			diaActual.setDate(diaActual.getDate() + 2);
		} else {
			diaActual.setDate(diaActual.getDate() - diaActual.getDay() + 1);
		}
		demanaAgenda();
	}
}

function carregaLlistaUsuaris() {

	var url = baseUrl + "dades/usuari.php?o=l";
	$("#usuari-dp option[value!='USUARI']").remove();
	$("#per-usuari option[value!='USUARI']").remove();
	$("#usuari-reserva option[value!='USUARI']").remove();
	$.get(url, function(data) {
		for (i = 0; i < data.length; i++) {
			usuaris[i] = new Usuari(data[i]);
			u = usuaris[i];
			$("#usuari-dp").append('<option value="' + u.usuari + '">' + u.usuari + " - " + u.nom + " " + u.cognoms + '</option>');
			$("#per-usuari").append('<option value="' + u.usuari + '">' + u.usuari + " - " + u.nom + " " + u.cognoms + '</option>');
			if (u.admin != 'S') {
				$("#usuari-reserva").append('<option value="' + u.usuari + '">' + u.usuari + " - " + u.nom + " " + u.cognoms + '</option>');
			}
		}
		$(".resultat").text("Usuaris carregats.").fadeIn(2000);
	}, "json")
			.error(function() {
		$(".resultat").text("Error prepararant llista usuari.").fadeIn(5000);
	});
	$(".resultat").text("usuaris carregats").fadeIn(5000);

}
/***
 * event de canvi de la llista d'usuaris de les dades personals.
 * mira l'usuari seleccionat i omple els controls.
 */
$("#usuari-dp").change(
		function canviaDadesUsuari() {
			var u = "";
			$("#usuari-dp option:selected").each(function() {
				uid = $(this).val();
			});
			for (i = 0; i < usuaris.length; i++) {
				if (usuaris[i].usuari == uid) {
					u = usuaris[i];
					break;
				}
			}
			mostraDadesUsuari(u);
		});

/***
 * amb les dades obtingudes a canviaDadesUsuari(), omple els diferents elements
 * de pantalla.
 * @param {type} us
 * @returns {undefined}
 */
function mostraDadesUsuari(us) {
	usuariDP = us.usuari;
	$("#usuari-txt-dp").val(us.usuari);
	$("#nom-dp").val(us.nom);
	$("#clau-dp").val(us.clau);
	$("#clau2-dp").val(us.clau);
	$("#cognoms-dp").val(us.cognoms);
	$("#nif-dp").val(us.nif);
	$("#tel-fix-dp").val(us.telefon_fix);
	$("#tel-mob-dp").val(us.telefon_mobil);
	$("#data-naixement-dp").val(us.data_naixement);
	$("#correu-e-dp").val(us.correu_e);
	$("#admin-dp").attr('checked', (us.admin ? true : false));
	if (usuari.admin) {
		$("#div-admin-dp").show();
		$("#botoNouUsuari").show();
	}
	else {
		$("#div-admin-dp").hide();
		$("#botoNouUsuari").hide();
	}
	$(".resposta").text("usuari : " + us.usuari);
}

/***
 * cridat pel bot de pantlla, neteja els camps de pantalla i la variable de 
 * control "usuariDP"
 * @returns {undefined}
 */
function nouUsuari() {
	usuariDP = "";
	$("#usuari-txt-dp").val("");
	$("#nom-dp").val("");
	$("#clau-dp").val("");
	$("#clau2-dp").val("");
	$("#cognoms-dp").val("");
	$("#nif-dp").val("");
	$("#tel-fix-dp").val("");
	$("#tel-mob-dp").val("");
	$("#data-naixement-dp").val("");
	$("#correu-e-dp").val("");
	$("#admin-dp").attr('checked', false);
	if (usuari.admin)
		$("#div-admin-dp").show();
	else
		$("#div-admin-dp").hide();
}

/***
 * validaci de dades i crida a la modificaci efectiva de les dades.
 * si la crida torna correctament, refresca l'agenda.
 * @returns {unresolved}
 */
function modificarDadesPersonals() {
	//validacoins
	var errors = "";
	if ($("#nom-dp").val().trim() == "") {
		errors += "El nom es obligatori; ";
	}
	if ($("#usuari-txt-dp").val().trim() == "") {
		errors += "usuari es obligatori; ";
	}
	if (($("#clau-dp").val().trim() != "" || $("#clau2-dp").val().trim() != "") &&
			$("#clau-dp").val() != $("#clau2-dp").val()) {
		errors += "Les claus no coincideixen; ";
	}
	if ($("#correu-e-dp").val().trim() == "") {
		errors += "El email es obligatori; ";
	}
	if (errors != "") {
		$("#textValidaDP").text(errors);
		$("#pValidaDP").popup("open");
		return;
	}
	operacio = (usuariDP == '' ? 'a' : 'm');
	url = baseUrl + "dades/usuari.php?o=" + operacio +
			"&usuari-dp=" + $("#usuari-txt-dp").val() +
			"&clau=" + $("#clau-dp").val() +
			"&nom=" + $("#nom-dp").val() +
			"&cognoms=" + $("#cognoms-dp").val() +
			"&nif=" + $("#nif-dp").val() +
			"&tel-fix=" + $("#tel-fix-dp").val() +
			"&tel-mob=" + $("#tel-mob-dp").val() +
			"&data-naix=" + $("#data-naixement-dp").val() +
			"&admin=" + ($("#admin-dp").is('checked') ? 'S' : 'N') +
			"&correu=" + $("#correu-e-dp").val();
	$.get(url, function(data) {
		$(".resultat").text(data.missatge).fadeIn(2000);
		demanaAgenda()
	}, "json")
			.error(function() {
		$(".resultat").text("Error modificant les dades personals.").fadeIn(5000);
	});

}

/*
 ******************************************************************************
 * AGENDA
 ******************************************************************************
 */

/***
 * constants per controla els canvi d'estat de les reserves.
 */
var ESTAT_ANULAT = "A";
var ESTAT_CONFIRMAT = "C";
var ESTAT_DISPONIBLE = "D";
var ESTAT_INACTIU = "I";
var ESTAT_NORMAL = "N";
var ESTAT_PENDENT = "P";
var ESTAT_RESERVAT = "R";
var ESTAT_SOLICITAT = "S";

/***
 * objecte de suport de les reserves.
 * @param {type} dades
 * @returns {Reserva}
 */
function Reserva(dades)
{
	this.reserva = dades.reserva;
	this.usuari = dades.usuari;
	this.data = dades.data;
	this.hora = dades.hora;
	this.servei = dades.servei;
	this.oferta = dades.oferta;
	this.comentaris = dades.comentaris;
	this.estat = dades.estat;
}

/***
 * demana la agenda per NUM_DIES.
 * en cas que torni correctament crida a preparaAgenda()
 * @returns {undefined}
 */
function demanaAgenda() {
	//carrega dades en base al diaActual	
	CarregaDates();
	url = baseUrl + "dades/agenda.php?o=c&dies=" + NUM_DIES + "&dia=" + diaActual.getDate() + "&mes=" + (diaActual.getMonth() + 1) + "&any=" + diaActual.getFullYear();
	//prompt(url,url);
	$(".resultat").text("Demana agenda.").fadeIn(2000);
	$.get(url, function(data) {
		preparaAgenda(data);
	}, "json")
			.error(function() {
		$(".resultat").text("Error preparant agenda.").fadeIn(2000);
	});
	$(".resultat").text("Agenda carregada.").fadeIn(2000);
}

/***
 * preparaci dels elements de l'agenda. 
 * passa els elements retornats a l'array "agenda" indexat per dia i hora.
 * @param {type} dades
 * @returns {undefined}
 */
function preparaAgenda(dades) {
	$("#divAgenda h1").text("Agenda de " + usuari.nom + " a QTN");
	//inicialitza l'array de visites
	$(".resultat").text("Prepara agenda. Reserves:" + dades.length).fadeIn(2000);
	agenda = new Array();
	for (i = 0; i < NUM_DIES; i++) {
		agenda[i] = new Array();
		for (j = 0; j < 16; j++) {
			agenda[i][hores[j]] = null;
		}
	}
	for (i = 0; i < dades.length; i++) {
		d = new Date(dades[i].data);
		h = dades[i].hora + "_00";
		$(".resultat").text("Reserva " + d + " " + h).fadeIn(2000);
		idia = datesIdx[d.getDate()];
		if (idia != undefined) {
			v = new Reserva(dades[i]);
			agenda[idia][h] = v;
			$(".resultat").text("Reserva " + v.data + " " + v.hora).fadeIn(2000);
		}
	}
	$(".resultat").text("Agenda preparada.").fadeIn(2000);
	//porta dades de les visites 
	pintaAgenda();
}

/***
 * posa les reserves a l'agenda. control de si es modus gesti per diferenciar
 * les reserves propies de la resta. Per un usuari normal, les reserves alienes
 * es veuen en gris, sense definici i sense capacitat d'acci. Un usuari de
 * gesti pot veure totes les reserves, actuan sobre qualsevol.
 * @returns {undefined}
 */
function pintaAgenda() {
	//en primer lloc, dibuixa la taula
	CreaTaulaAgenda();
	ara = new Date();
	hara = addZero(ara.getHours() + 3) + "_" + addZero(ara.getMinutes());
	for (idia = 0; idia < agenda.length; idia++) {
		//capalera
		//tdia = dates[idia].getDate() + "-" + (dates[idia].getMonth() + 1);
		for (j = 0; j < hores.length; j++) {
			hora = hores[j];
			esReservat = false;
			if (dataAnterior(dates[idia], ara) || (mateixDia(ara, dates[idia]) && parseInt(hara) > parseInt(hora))) {
				ref = "#cal_" + idia + "_" + hora;
				$(ref).addClass(ESTAT_INACTIU);
				esReservat = true;
			}

			if (!agenda[idia][hora])
				continue;

			v = agenda[idia][hora];
			d = new Date(v.data);
			h = v.hora + "_00";
			ref = "#cal_" + idia + "_" + h;
			if (usuari.admin || v.usuari == usuari.usuari) {
				$(ref).removeClass(ESTAT_SOLICITAT);
				$(ref).addClass(v.estat);
				if (usuari.admin)
					$(ref).text(serveis[v.servei] + "-" + v.usuari);
				else
					$(ref).text(serveis[v.servei]);
				//carrego select visites
			} else {
				$(ref).addClass(ESTAT_RESERVAT);
			}
		}
	}
	$(".resultat").text("");
	$.mobile.changePage("#pAgenda", "slide");
}

function esFestiu(f) {
	for (i = 0; i < festius.length; i++) {
		if (mateixDia(f, festius[i]))
			return true;
	}
	return false;
}

function CarregaDates() {
	var undia = new Date(diaActual);
	//prepara les dates, partint del dilluns de la setmana que toca
	for (idia = 0; idia < NUM_DIES; idia++) {
		dates[idia] = new Date(undia);
		datesIdx[undia.getDate()] = idia;
		undia.setDate(undia.getDate() + 1);
	}
}

/***
 * recarrega la agenda, mostrant la setmana anterior a l'actual
 * @returns {undefined}
 */
function SetmanaAnterior() {
	//recarrega l'array dates
	diaActual.setDate(diaActual.getDate() - 7);
	demanaAgenda();
}

/***
 * recarrega la agenda, mostrant la setmana segent a l'actual
 * @returns {undefined}
 */
function SetmanaSeguent() {
	//recarrega l'array dates
	diaActual.setDate(diaActual.getDate() + 7);
	demanaAgenda();
}

function CreaTaulaAgenda() {
	var avui = new Date();
	var tot = "<table class='t_calendari'>";
	tot += "<thead class='ui-widget-header'>";
	tot += "<tr>";
	tot += "<th id='h-calendari' class='h_calendari_hores'>";
	tot += "</th>";
	var cap = "";
	for (idia = 0; idia < dates.length; idia++) {
		tdia = diaSetmana[idia + 1] + dates[idia].getDate() + "/" + (dates[idia].getMonth() + 1);
		if (mateixDia(dates[idia], avui)) {
			cap += "<th id='cal_" + idia + "' class='h_calendari_visites avui'>" + tdia + "</th>";
		} else {
			cap += "<th id='cal_" + idia + "' class='h_calendari_visites'>" + tdia + "</th>";
		}
	}
	tot += cap;
	tot += "</tr>";
	tot += "</thead>";

	var tab = "<tbody id='b-calendari' class='ui-widget-content'>";
	for (ihora = 10; ihora < 14; ihora++) {
		tab += "<tr><td class='td_calendari head'>" + ihora + ":00</td>";
		for (idia = 0; idia < dates.length; idia++) {
			if (esFestiu(dates[idia]))
				tab += "<td class='td_calendari_festiu'>&nbsp;</td>";
			else
				tab += "<td id='cal_" + idia + "_" + ihora + "_00' class='td_calendari cell N' onclick='ferAccio(this)'>&nbsp;</td>";
		}
		tab += "</tr>";
	}
	tab += "<tr><td></td><td class='td_calendari_sep' colspan='" + NUM_DIES + "'></td></tr>";
	for (ihora = 15; ihora < 19; ihora++) {
		tab += "<tr><td class='td_calendari head'>" + ihora + ":00</td>";
		for (idia = 0; idia < dates.length; idia++) {
			if (esFestiu(dates[idia]))
				tab += "<td class='td_calendari_festiu'>&nbsp;</td>";
			else
				tab += "<td id='cal_" + idia + "_" + ihora + "_00' class='td_calendari cell N' onclick='ferAccio(this)'>&nbsp;</td>";
		}
		tab += "</tr>";
	}
	tab += "</tbody>";
	tab += "</table>";
	tot += tab;
	$("#grdCalendar").html(tot);
}

function mateixDia(d1, d2) {
	return (d1.getDate() == d2.getDate() && d1.getMonth() == d2.getMonth() && d1.getFullYear() == d2.getFullYear());
}

function dataAnterior(d1, d2) {
	if (d1.getFullYear() < d2.getFullYear()) {
		return true;
	} else if (d1.getFullYear() > d2.getFullYear()) {
		return false
	} else if (d1.getMonth() < d2.getMonth()) {
		return true;
	} else if (d1.getMonth() > d2.getMonth()) {
		return false;
	} else if (d1.getDate() < d2.getDate()) {
		return true;
	} else {
		return false;
	}
}

/***
 * ajuda per formatejar camps hora.
 * @param {type} i
 * @returns {Number}
 */
function addZero(i)
{
	if (i < 10) {
		i = "0" + i;
	}
	return i;
}

var curCel = null;
var estatAnt = null;
var estatAct = null;
var textAnt = null;

/***
 * acci dels usuaris sobre les celles de l'agenda. Depenent de l'estat de cada
 * cella, es prenen les decicions corresponentns.
 * Transicions possibles:
 * NORMAL -> SOLLICITUD
 * PENDENT -> DISPONIBLE (PER PASSAR A ANULLACI O CONFIRMACI)
 * CONFIRMAT -> REBUTX
 * 
 * @param {type} cella
 * @returns {undefined}
 */
function ferAccio(cella) {
	var botoRes = 0x0001;
	var botoAnu = 0x0010;
	var botoCon = 0x0100;
	var botoReb = 0x1000;
	var botons = 0;
	var cel = "#" + cella.id;
	idia = parseInt(cel.substr(5, 1));
	horaText = cel.substr(7, 2) + ":" + cel.substr(10, 2);
	h = cel.substr(7, 2) + "_" + cel.substr(10, 2);
	diaReserva = dates[idia].getFullYear() + "/" + (dates[idia].getMonth() + 1) + "/" + dates[idia].getDate();
	diaReservaDMA = dates[idia].getDate() + "/" + (dates[idia].getMonth() + 1) + "/" + dates[idia].getFullYear();
	horaReserva = cel.substr(7, 2);
	v = agenda[idia][h];

	if (!$(cel).hasClass(ESTAT_RESERVAT) && !$(cel).hasClass(ESTAT_INACTIU)) {
		//restaura estat anterior a cela anterior
		if (curCel != null) {
			$(curCel).removeClass(estatAct);
			$(curCel).addClass(estatAnt);
			$(curCel).text(textAnt);
		}

		textAnt = $(cel).text();
		if ($(cel).hasClass(ESTAT_SOLICITAT)) {
			estatAnt = ESTAT_SOLICITAT;
			estatAct = ESTAT_NORMAL;
			horaText = "";
			botons = 0;
		} else if ($(cel).hasClass(ESTAT_PENDENT)) {
			estatAnt = ESTAT_PENDENT;
			if (usuari.admin) {
				estatAct = ESTAT_DISPONIBLE; //previ a la confirmaci o rebutj
				botons = botoCon + botoReb;
			} else {
				estatAct = ESTAT_ANULAT;
				botons = botoAnu;
			}
		} else if ($(cel).hasClass(ESTAT_CONFIRMAT)) {
			estatAnt = ESTAT_CONFIRMAT;
			estatAct = ESTAT_ANULAT;
			botons = botoAnu;
		} else if ($(cel).hasClass(ESTAT_ANULAT)) {
			estatAct = estatAnt;
			estatAnt = ESTAT_ANULAT;
			horaText = "";
			botons = 0;
		} else {
			estatAct = ESTAT_SOLICITAT;
			estatAnt = ESTAT_NORMAL;
			botons = botoRes;
		}
		$(cel).addClass(estatAct);
		$(cel).removeClass(estatAnt);
		if (v) {
			usuariReserva = v.usuari;
			dadesReserva = "Reserva de " +
					v.usuari + " per el " + v.data.toLocaleString() + " a les " + v.hora + ":00" +
					"<br />Servei: " + serveis[v.servei] + " <br />" +
					v.comentaris;
			$("#dadesReserva").html(dadesReserva);
		} else {
			$("#dadesReserva").html("");
		}
		if (estatAct == ESTAT_SOLICITAT || !usuari.admin)
			$(cel).text(horaText);

		if (botons & botoRes) {
			$("#botoReservar").removeClass("ui-disabled");
		} else {
			$("#botoReservar").addClass("ui-disabled");
		}
		if (botons & botoAnu) {
			$("#botoAnular").removeClass("ui-disabled");
		} else {
			$("#botoAnular").addClass("ui-disabled");
		}
		if (botons & botoCon) {
			$("#botoConfirmar").removeClass("ui-disabled");
		} else {
			$("#botoConfirmar").addClass("ui-disabled");
		}
		if (botons & botoReb) {
			$("#botoRebutjar").removeClass("ui-disabled");
		} else {
			$("#botoRebutjar").addClass("ui-disabled");
		}
		$("#divReserva h3").text("Reserva " + diaReservaDMA + " " + horaText);
		curCel = cel;
	}
}

/***
 * events de canvis en les reserves. actualitzen la descripci de la reserva
 * a la part baixa de la pantalla.
 */
$("#servei-reserva").change(function() {
	descripcioReserva();
});
$("#oferta-reserva").change(function() {
	descripcioReserva();
});

/***
 * mostra la descripci de la reserva.
 * @returns {undefined}
 */
function descripcioReserva() {
	var desc = "Reservar per un servei ";
	servei = $("#servei-reserva").val();
	oferta = $("#oferta-reserva").val();

	if (servei != "SERVEI")
		desc += serveis[servei];
	if (oferta != "")
		desc += " amb la oferta " + oferta;

	desc += " el " + diaReservaDMA + " a les " + horaText;
	$("#descripcioReserva").text(desc);
}

/***
 * crida a la gravaci de la reserva a la BD.
 */
function demanaReserva() {
	//validacoins
	if ($("#servei-reserva").val().length > 1) {
		$("#textValidaReserva").text("Sisplau, seleccioni un servei.");
		$("#pValidaReserva").popup("open");
		return;
	}
	if (usuari.admin) {
		if ($("#usuari-reserva").val() == "USUARI") {
			$("#textValidaReserva").text("Sisplau, seleccioni un usuari.");
			$("#pValidaReserva").popup("open");
			return;
		}
		usuariReserva = $("#usuari-reserva").val();
	} else {
		usuariReserva = usuari.usuari;
	}
	url = baseUrl + "dades/agenda.php?o=r" +
			"&usuari-reserva=" + usuariReserva +
			"&dia-reserva=" + diaReserva +
			"&hora-reserva=" + horaReserva +
			"&servei-reserva=" + $("#servei-reserva").val() +
			"&oferta-reserva=" + prepararURL($("#oferta-reserva").val()) +
			"&comentaris-reserva=" + prepararURL($("#comentaris-reserva").val()) +
			"&estat-reserva=" + ESTAT_PENDENT;
	$.get(url, function(data) {
		$(curCel).text(data.missatge);
		estatAct = ESTAT_SOLICITAT;
		estatAnt = ESTAT_PENDENT;
		textAnt = serveis[$("#servei-reserva").val()];
		$(".resultat").text("Reserva realitzada.").fadeIn(3000);
		demanaAgenda()
	}, "json")
			.error(function() {
		$(".resultat").text("Error fent la reserva.").fadeIn(2000);
	});
}

/***
 * crida a l'anulaci de la reserva. En cas de fer-se correctament,
 * el procediment enviar un missatge al client.
 */
$("#anulacioReserva").click(
		function anulaReserva() {
			idia = parseInt(curCel.substr(5, 1));
			horaText = curCel.substr(7, 2) + ":" + curCel.substr(10, 2);
			horaReserva = curCel.substr(7, 2);
			diaReserva = dates[idia].getFullYear() + "/" + (dates[idia].getMonth() + 1) + "/" + dates[idia].getDate();
			raons = $("#raons-ar").val();
			if (usuari.admin)
				usuariPer = usuariReserva;
			else
				usuariPer = usuariQTN;			
			url = baseUrl + "dades/agenda.php?o=a&usuari-reserva=" + usuariReserva + "&per-usuari=" + usuariPer + "&dia-reserva=" + diaReserva + "&hora-reserva=" + horaReserva + "&raons=" + prepararURL(raons);
			$.get(url, function(data) {
				$(curCel).text(data.missatge);
				estatAct = ESTAT_ANULAT;
				estatAnt = ESTAT_NORMAL;
				$(".resultat").text("Reserva anulada per raons:" + raons).fadeIn(5000);
				$("#dadesReserva").html("");
				carregaMissatges();
			}, "json")
					.error(function() {
				$(".resultat").text("Error anul\u00B7lant reserva.").fadeIn(5000);
			});
		});

/***
 * envia la confirmaci de la reserva a la BD.
 */
$("#confirmacioReserva").click(
		function confirmaReserva() {
			idia = parseInt(curCel.substr(5, 1));
			horaText = curCel.substr(7, 2) + ":" + curCel.substr(10, 2);
			horaReserva = curCel.substr(7, 2);
			diaReserva = dates[idia].getFullYear() + "/" + (dates[idia].getMonth() + 1) + "/" + dates[idia].getDate();
			url = baseUrl + "dades/agenda.php?o=cr&usuari-reserva=" + usuariReserva + "&dia-reserva=" + diaReserva + "&hora-reserva=" + horaReserva;
			$.get(url, function(data) {
				$(curCel).text(data.missatge);
				estatAct = ESTAT_DISPONIBLE;
				estatAnt = ESTAT_CONFIRMAT;
				$(".resultat").text("Reserva confirmada.").fadeIn(3000);
			}, "json")
					.error(function() {
				$(".resultat").text("Error anul\u00B7lant reserva.").fadeIn(5000);
			});
		});

/***
 * efectua l'esborrat de la reserve per rebuitx d'una solicitud. El procediment
 * de servidor enviar un missatge al client.
 */
$("#rebutjReserva").click(
		function rebutjReserva() {
			idia = parseInt(curCel.substr(5, 1));
			horaText = curCel.substr(7, 2) + ":" + curCel.substr(10, 2);
			horaReserva = curCel.substr(7, 2);
			diaReserva = dates[idia].getFullYear() + "-" + (dates[idia].getMonth() + 1) + "-" + dates[idia].getDate();
			raons = $("#raons-rr").val();
			//sempre es usuari admin
			usuariPer = usuariReserva;
			url = baseUrl + "dades/agenda.php?o=a&usuari-reserva=" + usuariReserva + "&per-usuari=" + usuariPer + "&dia-reserva=" + diaReserva + "&hora-reserva=" + horaReserva + "&raons=" + prepararURL(raons);
			$.get(url, function(data) {
				$(curCel).text(data.missatge);
				estatAct = ESTAT_DISPONIBLE;
				estatAnt = ESTAT_NORMAL;
				$(".resultat").text("Reserva rebutjada per raons: " + raons).fadeIn(5000);
				$("#dadesReserva").html("");
				carregaMissatges();
			}, "json")
					.error(function() {
				$(".resultat").text("Error anul\u00B7lant reserva.").fadeIn(3000);
			});
		});

/*
 ******************************************************************************
 * ATENCIO CLIENTS
 ******************************************************************************
 */
/***
 * objecte de suport dels missatges.
 * @param {type} dades
 * @returns {Missatge}
 */
function Missatge(dades)
{
	this.missatge = dades.missatge;
	this.tipus_missatge = dades.tipus_missatge;
	this.assumpte = dades.assumpte;
	this.de_usuari = dades.de_usuari;
	this.per_usuari = dades.per_usuari;
	this.data = dades.data;
	this.text_missatge = dades.text_missatge;
	this.estat = dades.estat;
}

/***
 * enviament d'un missatge al servidor per gravaci.
 * es validen previament les dades del missatge.
 * @returns {unresolved}
 */
function demanaAC() {
	//validacoins	
	var errors = "";
	if ($("#assumpte-ac").val().trim() == "") {
		errors += "L'assumpte es obligatori; ";
	}
	if ($("#tipus-ac").val().length > 1) {
		//errors += "El tipus es obligatori; ";
		$("#tipus-ac").val("A");
	}
	if (errors != "") {
		$("#textValidaAC").text(errors);
		$("#pValidaAC").popup("open");
		return;
	}
	if (missatgeSel == null || !usuari.admin) {
		url = baseUrl + "dades/missatge.php?o=a" +
				"&tipus_missatge=" + $("#tipus-ac").val() +
				"&assumpte=" + prepararURL($("#assumpte-ac").val()) +
				"&de_usuari=" + usuari.usuari +
				"&per_usuari=" + usuariQTN +
				"&text_missatge=" + prepararURL($("#comentaris-ac").val());
	} else {
		url = baseUrl + "dades/missatge.php?o=a" +
				"&tipus_missatge=" + $("#tipus-ac").val() +
				"&assumpte=RE:" + prepararURL($("#assumpte-ac").val()) +
				"&de_usuari=" + usuariQTN +
				"&per_usuari=" + missatgeSel.per_usuari +
				"&text_missatge=" + $("#resposta-ac").val();
	}
	$.get(url, function(data) {
		$(".resultat").text(data.missatge).fadeIn(5000);
		demanaAgenda()
	}, "json")
			.error(function() {
		$(".resultat").text("Error enviant missatge.").fadeIn(5000);
	});
}

/***
 * event de canvi de missatge seleccionat. Mostra les dades del missatge
 */
$("#missatge-ac").change(
		function canviaDadesMissatge() {
			var u = "";
			$("#missatge-ac option:selected").each(function() {
				mid = $(this).val();
			});
			for (i = 0; i < missatges.length; i++) {
				if (missatges[i].missatge == mid) {
					m = missatges[i];
					break;
				}
			}
			$(".resultat").text("mostrant missatge de " + m.de_usuari + " (" + m.missatge + ")").fadeIn(3000);
			mostraDadesMissatge(m);
		});

/***
 * marca el missatge com llegit. En la versi actual noms es mostren els
 * missatges pendents de lectura.
 * @returns {undefined}
 */
function llegirMissatge() {
	url = baseUrl + "dades/missatge.php?o=m&missatge=" + missatgeSel.missatge + "&estat=L";
	$.get(url, function(data) {
		$(".resultat").text("Missatge marcat com llegit.").fadeIn(2000);
		carregaMissatges();
	}, "json")
			.error(function() {
		$(".resultat").text("Error marcant missatge.").fadeIn(5000);
	});
}

/***
 * carrega la llista de missatges de l'atenci a clients.
 * @returns {undefined}
 */
function carregaMissatges() {
	//CARREGA MISSATGES	
	$("#missatge-ac option[value!='0']").remove();

	var url = baseUrl + "dades/missatge.php?o=l&per-usuari=";
	if (usuari.admin)
		url += usuariQTN;
	else
		url += usuari.usuari;

	$.get(url, function(data) {
		for (i = 0; i < data.length; i++) {
			missatges[i] = new Missatge(data[i]);
			m = missatges[i];
			if (usuari.admin)
				t = '<option value="' + m.missatge + '">' + m.data + " - " + m.de_usuari + " : " + m.assumpte + '</option>';
			else
				t = '<option value="' + m.missatge + '">' + m.data + " : " + m.assumpte + '</option>';
			$("#missatge-ac").append(t);
		}
	}, "json")
			.error(function() {
		$(".resultat").text("Error prepararant llista missatges.").fadeIn(5000);
	});
	return missatges.length;
}

/***
 * passa les dades als elements de pantalla.
 * diferencia el modus gesti per mostrar els elements 
 * @param {type} mi
 * @returns {undefined}
 */
function mostraDadesMissatge(mi) {
	var tipusAc = new Array();
	tipusAc["D"] = "Demanar informaci&oacute;";
	tipusAc["P"] = "Fer una proposta";
	tipusAc["Q"] = "Fer una queixa";
	tipusAc["V"] = "Comentar reserva";
	tipusAc["A"] = "Altres";


	missatgeSel = mi;
	$("#per-usuari").val(mi.per_usuari);
	$("#assumpte-ac").val(mi.assumpte);
	$("#tipus-ac-show").val(tipusAc[mi.tipus_missatge]);
	$("#comentaris-ac").val(mi.text_missatge);
	$("#de-usuari").val(mi.de_usuari);
	$("#data-ac").val(mi.data);
	$("#div-tipus-missatge").hide();
	$("#div-tipus-missatge-show").show();

	$("#botoLlegirMissatge").show();
	$("#div-per-usuari").hide();
	$("#div-comentaris-ac").attr('readonly', true);
	$("#div-data-ac").show();
	if (usuari.admin) {
		$("#div-resposta-ac").show();
		$("#div-de-usuari").show();
		$("#botoEnviarMissatge").show();
	} else {
		$("#botoEnviarMissatge").hide();
	}

}

/***
 * neteja de camps de pantalla per enviar un nou missatges.
 * diferencia el modus gesti per mostra els elements adaptats a l'usuari
 * @param {type} mi
 * @returns {undefined}
 */
function nouMissatgeAC(mi) {
	missatgeSel = null;
	$("#per-usuari").val("MISSATGES");
	$("#assumpte-ac").val("");
	$("#tipus-ac").val("TIPUS MISSATGE");
	$("#comentaris-ac").val("");

	$("#div-tipus-missatge").show();
	$("#div-tipus-missatge-show").hide();
	$("#divMissatgesAC").hide();
	$("#botoNouMissatge").hide();
	$("#botoLlistaMissatge").show();

	$("#botoLlegirMissatge").hide();
	$("#div-comentaris-ac").attr('readonly', false);
	$("#div-resposta-ac").hide();
	$("#div-de-usuari").hide();
	$("#div-data-ac").hide();
	$("#botoEnviarMissatge").show();
	if (usuari.admin)
		$("#div-per-usuari").show();

	carregaMissatges();
}

function llistaMissatgeAC() {
	carregaMissatges();

	missatgeSel = null;
	$("#per-usuari").val("MISSATGES");
	$("#assumpte-ac").val("");
	$("#tipus-ac").val("TIPUS MISSATGE");
	$("#comentaris-ac").val("");

	$("#div-tipus-missatge").hide();
	$("#div-tipus-missatge-show").hide();
	$("#div-per-usuari").hide();
	$("#divMissatgesAC").show();
	$("#botoNouMissatge").show();
	$("#botoLlistaMissatge").hide();

	$("#botoLlegirMissatge").hide();
	$("#div-comentaris-ac").attr('readonly', false);
	$("#div-resposta-ac").hide();
	$("#div-de-usuari").hide();
	$("#div-data-ac").hide();
	$("#botoEnviarMissatge").show();

}

function prepararURL(t) {
	var s = encodeURIComponent(t);
	return s;
}
